#!/usr/bin/perl -w
use strict;

putHtml();
exit(0);

##
##
sub getHinsi{
    my %wordhinsi = ();
    my @alreadyDefinedHinsi = `ls hinsi*.def`;
    foreach my $f (@alreadyDefinedHinsi){
        open(IN, $f);
        while(<IN>){
            my ($word,$hinsi) = /^(.*):([A-Z0-9]*)$/;
            $wordhinsi{$word} = $hinsi;
        }
        close(IN);
    }
    return %wordhinsi;
}



##
## fromskk.ctd  HTML form Ѵ
##
sub putHtml{
    my %wordhinsi = getHinsi();
    my $WORD_PER_PAGE = 150;
    my @alreadyArised = (); # ˽ФƤܸñϿƤ2٤Ǥʤå롣

    ## read data
    open(IN, "fromskk.ctd") || die "cannot open 'fromskk.ctd'";
    my @fromskk = <IN>;
    chomp(@fromskk);
    close(IN);

    my $i=0;
    for($i=0; $i<=$#fromskk; $i+=$WORD_PER_PAGE){
        my $outfile = sprintf("hinsi%04d.html", $i);
        open(OUT, ">$outfile");

        ## HTML no1
        putheader($i);

        for(my $j=0; $j<=$WORD_PER_PAGE; $j++){

            ## fromskk.ctd ΰԤʬΥ
            my $tmp = $fromskk[$i + $j];
            next if(!defined $tmp || $tmp eq '');
            $tmp =~ /^([^ ]*) [\#T35]* (.*)$/;
            my ($alphabet,$jpnwords) = ($1, $2);
            die "'$tmp'" if(!defined $jpnwords);

            my $yakuhukusuu = 0; # 줬ʣȤʬ̤뤿
            foreach my $word (split(/ +/,$jpnwords)){
                ## ˴Фå
                my $isAlreadyRegistered = 0;
                foreach (@alreadyArised){
                    if($_ eq $word){ $isAlreadyRegistered = 1; }
                }
                next if $isAlreadyRegistered;


                ## ʻ줬˻ꤵƤ
                my $definition = "T35";
                if(defined $wordhinsi{$word}){ $definition = $wordhinsi{$word}; }

                ## HTML no2
                printf OUT qq|<tr>\n<td class="count">%05d</td>\n|, $i+$j;
                print OUT qq|<td><a href="http://dictionary.goo.ne.jp/search.php?MT=$alphabet">$alphabet</a></td>\n<td><a href="http://www.google.co.jp/search?ie=euc-jp&q=$word">$word</a></td>\n<td>\n|;

                ## ʻɽ
                my @hinsidesc = ("T35","̾", #"T35"=>"̾(Ū̾)",
                                 "CN","̾",
                                 "JN","̾",
                                 "KK","/",
                                 #"T09","",  #"T09"," Ť,",
                                 "T30","̾" # "T30"=>"̾ ,",
                                 );
                my %hinsidesc = @hinsidesc;

                for(my $k=0; $k<=$#hinsidesc; $k+=2){
                    my $hinsi = $hinsidesc[$k];
                    my $desc = $hinsidesc[$k+1];
                    my $checked = "";
                    if($definition eq $hinsi){ $checked = " checked"; }
                    printf OUT qq|  <input type="radio" name="w%05d.%d"|, $i+$j,$yakuhukusuu;
                    print OUT qq| value="$word:$hinsi"$checked><span class="ri">$desc</span>\n|;
                }

                ## HTML no4
                print OUT "</td>\n</tr>\n";
                $yakuhukusuu++;
                push @alreadyArised, $word;
            } #foreach(split $jpnwords)
        } #for($j)

        print OUT qq|</table><input type="submit"></form></body></html>\n|;
        close(OUT);
    } #for($i)


    ## ܼڡ
    ##
    open(OUT, ">index.html");
    print OUT qq|<html><body><h1>page</h1><p>|;
    for(my $j=0; $j<=$i; $j+=$WORD_PER_PAGE){
        printf OUT qq|<a href="hinsi%04d.html">%04d</a>\n|, $j, $j;
    }
    print OUT qq|</p></body></html>|;
}


sub putheader{
    my ($pagenum) = @_;
        print OUT qq|<html>
<head>
  <meta http-equiv="content-type" content="text/html; charset=euc-jp">
  <title>page $pagenum</title>
  <style type="text/css" media="all">
  <!--
  td {
    text-align: top;
    border-bottom: 1px solid \#eee;
  }
  .ri {
    /* radiobox item */
    font-size: 80%;
  }
  td.count {
    background: \#ccc;
  }
  th { text-align: left;
    background: \#99c;
  }
  a {
    color: \#000;
    text-decoration: none;
  }
  -->
  </style>
</head>
<body>
<form action="exechinsi.cgi" method="post">
<input type="hidden" name="hinsifilename" value="hinsi$pagenum.def">
<table>
<tr>
  <th>ֹ</th>
  <th>ե٥å</th>
  <th></th>
  <th>ʻ (<a href="http://www.db.is.kyushu-u.ac.jp/~moriki/Canna/main.code"></a>)</th>
</tr>\n|;
}
#endoffile
