#!/usr/bin/perl -w
use strict;
## ե٥å֤ΤޤޤǤ canna ȤƤϻȤʤΤǡ
## ե٥å֤ʬҤ餬ʺˤ롣
## Time-stamp: "Feb 10 2004"
## Author:     Itou Hiroki
## usage:      $ perl alpha2kana.pl fromskk.ctd romakana.txt > skkalpha.ctd

mainfunc();
exit();

sub mainfunc{
    my ($conv, $convindex) = setRomaKanaConv($ARGV[1]);
    print STDERR "setRomaKanaConv end\n";
    my $hinsi = setHinsiInfo();
    print STDERR "setHinsiInfo end\n";
    readWriteCannaDic($ARGV[0], $conv, $convindex, $hinsi);
}


## ޻  Ѵ Υ롼ɤ߹
##  ˤѴ§Τۤͥ褵
sub setRomaKanaConv{
    my ($convfile) = @_;
    my %conv = ();
    my @convindex = (); # ϥåȽ¸ʤΤǡ̤¸

    open(CONVTABLE, $convfile);
    while(<CONVTABLE>){
        next if (/^\#/ || /^[ \t]*$/); ## 򡦥ȹԤ̵
        s/[ \t\r\n]*$//;  #˲ԡ򤬤к
        /^([^ \t]*)[\t ]+(.*)$/;
        my $kana = $1;
        foreach my $roma (split(/ /,$2)){
            $conv{$roma} = $kana;
            ## print "@@ $roma:$kana\n";
            push @convindex, $roma;
        }
    }
    close(CONVTABLE);

    return \%conv, \@convindex;
}


##
## ʻɤ߹
sub setHinsiInfo{
    my %hinsi = ();
    my @hinsifile = `ls hinsi*.def`;

    foreach my $f (@hinsifile){
        open(IN, $f);
        foreach(<IN>){
            chomp();
            next if(/^[ \t\r\n]$/);  ## 򡦥ȹԤ̵
            m/^([^\:]*):(.*)$/;
            my ($yomigana,$sonohinsi) = ($1,$2);
            $hinsi{$yomigana} = $sonohinsi;
        }
        close(IN);
    }
    return \%hinsi;
}


## cannaɤ߹
sub readWriteCannaDic{
    my ($alphadic, $conv, $convindex, $hinsi) = @_;

    open(DIC, $alphadic);
    while(<DIC>){
        chomp();
        next if(/^\#/ || /^[ \t]*$/);
        my @elem = split(/[ \t]/, $_);
        my $src = $elem[0];

        ##
        ## ޻  Ѵ
        foreach(@$convindex){
            if($src =~ /$_/){
                $src =~ s/$_/$$conv{$_}/g;
            }
        }
        ## ss  ֤s   # ll,xxפϽ
        while($src =~ /([a-km-wyz])\1/){
            my $s = $1;
            $src =~ s/$s$s/$s/;
        }
        ## tch - > ֤ch
        while($src =~ /tch/){
            $src =~ s/tch/ch/;
        }
        ## n  ֤ #  ny ϡ֤yפǤϤʤny
        if($src =~ /n[^y]/){
            $src =~ s/n//g;
        }
        $src =~ s/n$//;

        print STDERR "'$src'\n";

        ##
        ## 
        print $src;


        ##
        ## ʻ
        {
            my %hinsiHash = ();
            ## ʻ줴ȤˤޤȤ
            foreach my $i (2..$#elem){
                if(!defined $$hinsi{$elem[$i]}){
                    $$hinsi{$elem[$i]} = "T35";
                }
                my $h = $$hinsi{$elem[$i]};
                push @{$hinsiHash{$h}}, $elem[$i];
            }
            # ʻ줴Ȥ˽Ϥ
            foreach my $k (sort keys %hinsiHash){
                print " \#$k";
                foreach (@{$hinsiHash{$k}}){
                    print " ".$_;
                }
            }
        }

        print "\n";
    }
    close(DIC);
}
